# SSO


## 創建服務SSO

### 僅提供後台創建
- 名稱(非主鍵，視為暱稱可更改)
- 說明
- 網址
- 網站識別碼webId
- 轉址
- 網站logo圖片


## 使用者資訊欄位
- 姓名
- 密碼(加鹽後sha512處理)
- email
- 身份
- 單位
- 是否有效
- 有效時間
- 創建時間
- 是否驗證
- 驗證時間
- 封鎖狀態，多次登入或過量使用API時，標記為封鎖狀態，供防禦之用
- 封鎖起始時間
- 允許ip，提供多組ip設定，供有限來源之用
- 備註


## 設定(由SSO設定檔提供)
- Email Server資訊如網址或ip與port
- 使用者密碼加鹽
- 是否可於登入頁提供申請註冊使用者按鈕
- 使用者登入時，是否使用圖形驗證碼模組
- 使用者成功登入後產生token之有效(過期)時間m(30)分鐘
- 使用者n(10)分鐘內最大登入失敗次數m(3)，若觸發則進入封鎖狀態p(30)分鐘
- 使用者n(10)分鐘內最大調用API次數m(1000)，若觸發則進入封鎖狀態p(30)分鐘
- IP使用者n(10)分鐘內最大調用API次數m(10000)，若觸發則IP進入封鎖狀態p(30)分鐘
- 清除(移動至備份表)紀錄使用者與IP連線log機制，偵測時間n(1)天，保留最新資料時間m(60)天
- 是否啟用要求使用者定期更換密碼。若是，預設6個月更換密碼，是否允許使用同樣密碼


## 使用者登入

### 一般使用者或SSO系統管理者登入
1. 瀏覽登入頁，配合網站識別碼webId顯示應用系統名稱與logo圖
2. 輸入帳密
3. 若有開啟使用圖形驗證碼，則需輸入圖形驗證碼
4. 若帳密通過且帳號有效且為允許ip且非封鎖狀態，則放行，反之一律回傳使用者帳密錯誤避免被猜測
6. 偵測若已有成功登入並產生token，僅重設有效時間m(30)分鐘並回傳既有token
7. 登入後，轉址配token再重導至指定應用系統
8. 使用者瀏覽器儲存區(例如localStorage)儲存token供後續自動登入之用

### 一般使用者登入後台
1. 一般使用者登入後，通過後台網址可看見自身之使用者資訊
2. 可變更基本資訊，例如顯示身份或單位等
3. 可變更密碼，須通過接收驗證信方能允許變更
4. 可變更Email，須通過接收驗證信方能允許變更

### SSO系統管理者登入後台
1. 一般使用者登入後，通過後台網址可看見自身之使用者資訊
2. 可變更基本資訊，例如顯示身份或單位等
3. 可變更密碼，須通過接收驗證信方能允許變更
4. 可變更Email，須通過接收驗證信方能允許變更
5. 提供使用者清單，可顯示使用者已驗證/未驗證狀態，已封鎖/未封鎖狀態，可新增使用者，可重置使用者密碼為指定或隨機密碼
6. 提供變更設定，例如：
    - 使用者帳號成功登入後產生token之有效(過期)時間，預設30分鐘
    - 使用者帳號預設10分鐘內最大登入失敗次數預設為3次，若觸發則使用者帳號進入封鎖，預設封鎖30分鐘
    - 使用者IP預設10分鐘內最大調用API次數10000次，若觸發則使用者IP進入封鎖，預設封鎖30分鐘
7. 提供當前token登入清單。因可同帳號多裝置登入，故同一使用者可同時擁有多組已登入token。提供強制登出功能，代表刪除指定已登入token
8. 提供當前封鎖清單。主要提供封鎖使用者與IP清單。提供解除IP封鎖與解除使用者封鎖
9. 提供系統金鑰清單。主要提供給應用系統用之系統金鑰清單。提供新增、變更與刪除系統金鑰功能。

### 使用者自動登入機制
1. 由使用者瀏覽器儲存區(例如localStorage)讀取之前暫存token，調用驗證token API確認使用者登入token是否有效
2. 若有效則再調用由token取得使用者資訊API，取得使用者資訊
3. 若無效則轉回SSO登入頁

### 使用者於多裝置登入
1. 多裝置登入用不同token作為區別
2. 登出時偵測該token所屬使用者，需同步登出。代表刪除該使用者當前所使用全部已登入token


## 新增使用者

### 後台新增使用者
1. 按新增使用者
2. 給予姓名、隨機初始密碼、email、身份、單位與相關資訊
3. 寄註冊驗證信給使用者
4. 使用者點信內連結
5. 系統收到網址請求
6. 使用者註冊驗證通過
7. 若使用者一直未驗證，則於使用者資訊清單可提供重發驗證信功能
8. 若使用者反應沒收到驗證信，若SSO系統管理員確認使用者資訊無誤，則可強制更改為已驗證

### 使用者於登入頁註冊使用者
1. 按申請註冊使用者
2. 給予姓名、密碼、確認密碼、email、身份與單位等相關資訊
3. 點擊送出申請
4. 寄給使用者驗證信
5. 使用者點信內連結
6. 系統收到網址請求
7. 使用者註冊驗證通過
8. 若使用者沒收到驗證信請跟SSO系統管理員反應


## 變更使用者密碼

### 後台變更使用者密碼
1. 點擊使用者，彈出使用者資訊頁
2. 按強制變更使用者密碼
3. 覆寫使用者密碼為隨機初始密碼
4. 寄註冊驗證信給使用者
5. 使用者點信內連結
6. 系統收到網址請求
7. 使用者變更密碼驗證通過
8. 變更密碼後後端需刪除使用者當前已產生之token
9. 使用者瀏覽器儲存區(例如localStorage)內token雖無法刪除，但會被後端驗證API時擋掉
10. 若使用者反應沒收到驗證信，若SSO系統管理員確認使用者資訊無誤，那直接重新進行變更使用者密碼作業

### 使用者於登入頁變更密碼
1. 轉至使用者資訊頁
2. 按變更密碼
3. 給予密碼、確認密碼
4. 點擊送出申請
5. 寄給使用者驗證信
6. 使用者點信內連結
7. 系統收到網址請求
8. 使用者變更密碼驗證通過
9. 變更密碼後後端需刪除使用者當前已產生之token
10. 變更密碼後前端可順便刪除瀏覽器儲存區(例如localStorage)內token，沒刪亦可
11. 若使用者沒收到驗證信請跟應用系統管理員或SSO系統管理員反應


## 變更使用者資訊

### 後台變更使用者資訊
1. 點擊使用者，彈出使用者資訊頁
2. 按變更使用者資訊
3. 修改使用者資訊
4. 按確定後則進行變更

### 使用者於登入頁變更資訊
1. 轉至使用者資訊頁
2. 按變更使用者資訊
3. 修改使用者資訊
4. 按確定後則進行變更


## 刪除使用者

### 後台刪除使用者
1. 點擊使用者，彈出使用者資訊頁
2. 按刪除使用者
3. 再次確認
4. 按確定後則進行變更有效欄位，非真的刪除
5. 刪除後後端需刪除使用者當前已產生之token
6. 使用者瀏覽器儲存區(例如localStorage)內token雖無法刪除，但會被後端驗證API時擋掉


## 登出使用者
1. 於應用站台或後台點擊登出按鈕
2. 登出後後端需刪除使用者當前已產生之token
3. 若使用者同時多裝置登入，則須偵測使用者同時登入之token一併登出與刪除
4. 登出後前端可順便刪除瀏覽器儲存區(例如localStorage)內token，沒刪亦可


### 提供登入出事件
- 提供網站識別碼webId頻道內使用者登入與登出事件
- 提供token過期事件，亦驅動使用者登出
- 提供token即將過期事件，於過期前例如1分鐘觸發，收到則視需要呼叫更新token時效API


## API

### 使用者登入API
1. 提供帳密
2. 驗證帳號有效且為允許ip且非封鎖狀態
3. 回傳驗證狀態，若成功再另提供token

### 使用者外部登入API
1. 提供外部服務名稱與轉址(外部服務登入頁)
2. 於前端開啟轉址
3. 回傳驗證狀態，若成功再另提供token

### 擴充外部使用者清單API
- 可傳入外部清單名稱orgGroup與使用者清單
- 每次傳入則一律清除指定外部清單名稱orgGroup內所屬使用者，也就是能針對指定外部單位全部刷新，但不影響其他單位
- 開發者可配合定時器自動重刷外部使用者清單，例如更新指定AD下使用者清單至SSO內

### 驗證token API
1. 外部應用系統後端或前端網頁提供token
2. 驗證token是否存在，且是否在有效期內
3. (暫時不使用)驗證token所對應帳號有效且為允許ip且非封鎖狀態
4. 回傳驗證狀態，若驗證失敗則另提供失敗訊息

### 由token取得使用者資訊API
1. 外部應用系統後端或前端提供token
2. 調用驗證token API
3. 驗證成功回傳使用者資訊，否則回傳驗證失敗訊息

### 由token取得全部使用者清單API
1. 外部應用系統後端或前端提供token
2. 調用驗證token API
3. SSO提供本身使用者清單
4. 提供過往擴充外部使用者清單
5. 驗證成功回傳全部使用者清單，否則回傳驗證失敗訊息

### 外部應用系統由token更新token用API
1. 外部應用系統後端或前端提供token
2. 調用驗證token API
3. 驗證成功回傳更新狀態，若成功另提供新token，否則回傳驗證失敗訊息

#### 用法

##### 被動偵測
- 前端使用者偵測滑鼠或動態事件
- 基於debounced調用更新API，避免token過期
- 暫無需要後端登入與更新

##### 主動偵測
- 前端使用者調用API或使用timer偵測token內時效
- 若發現快過期(指定門檻內)則調用更新API，避免token過期
- 前後端皆須使用此功能

### 存取使用者擴充欄位API
1. 外部應用系統後端或前端提供token
2. 調用驗證token API
3. 驗證成功回傳取得或變更使用者擴充欄位資訊，否則回傳驗證失敗訊息

### 提供log資訊API
1. 外部應用系統後端或前端提供token
2. 調用驗證token API
3. 驗證成功回傳取得log資訊供外部呈現或再整合，否則回傳驗證失敗訊息

### 提供log資訊API
1. 外部應用系統後端或前端提供token
2. 調用驗證token API
3. 驗證成功回傳取得log資訊供外部呈現或再整合，否則回傳驗證失敗訊息


## Log

### 主要機制
- 紀錄各API事件，紀錄使用者提供之網址、網址參數、header與(可能的)精簡回傳資訊
- 使用者登入成功與失敗一定要紀錄，供防禦與告警之用
- 各事件若有token需儲存token
- 儲存對應清單token2users，紀錄各token對應使用者主鍵，供使用者行為偵測用
- 儲存log依資安要求不能以明文儲存，若用log4js儲存得配合加密(並把密碼寫於SSO設定檔)，或是直接儲存於有帳密保護之資料庫

### 展示

#### 選擇起訖時間
- 提供選擇起訖時間組件
- 提供下拉選日、月、季、半年、年，起訖時間則為自動由本日往前算，例如日則為凌晨0點至23:59，月為1日至本日，其餘月為1日至該月底，其他依此類推

#### 展示資訊
- 依照起訖時間展示log資訊，各log若有token，基於對應清單token2users反查使用者姓名與email
- 依照起訖時間展示期間內使用者調用API次數統計，統計次數範圍例如給1分鐘，1分鐘若有10次則該分鐘0秒處給予值10，依此繪製隨時間之調用API次數統計圖


## 防禦
- 提取SSO設定檔
- 使用定時器偵測計算使用者行為資訊
- 計算使用者於指定時間內最大登入失敗次數
- 計算使用者於指定時間內最大調用API次數
- 若觸發條件則修改使用者資訊進入封鎖狀態
- 使用定時器偵測與解鎖
- 使用者成功登入後產生token之有效(過期)時間m(30)分鐘
- 使用者n(10)分鐘內最大登入失敗次數m(3)，若觸發則進入封鎖狀態p(30)分鐘
- 使用者n(10)分鐘內最大調用API次數m(1000)，若觸發則進入封鎖狀態p(30)分鐘
- IP使用者n(10)分鐘內最大調用API次數m(10000)，若觸發則IP進入封鎖狀態p(30)分鐘

